using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;

namespace Decal.Interop.Input;

[ComImport]
[ClassInterface(ClassInterfaceType.None)]
[Guid("F3170E85-517E-43A4-B7B4-6F006A7B1B85")]
[SuppressUnmanagedCodeSecurity]
[ComSourceInterfaces("Decal.Interop.Input.IWinMsgHookEvents\0\0")]
[TypeLibType(2)]
public class WinMsgHookClass : IWinMsgHook, WinMsgHook, IWinMsgHookEvents_Event
{
	[DispId(1)]
	public virtual extern object Tag
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[DispId(1)]
		[return: MarshalAs(UnmanagedType.Struct)]
		get;
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[DispId(1)]
		[param: In]
		[param: MarshalAs(UnmanagedType.Struct)]
		set;
	}

	[DispId(2)]
	public virtual extern bool Enabled
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[DispId(2)]
		get;
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[DispId(2)]
		[param: In]
		set;
	}

	public virtual extern event IWinMsgHookEvents_MessageEventHandler Message;
}
